/*

Si vuole scrivere un programma C per la gestione delle informazioni relative agli esami per la patente. 
Il programma deve prevedere due strutture dati. Una per le persone che devono sostenere l'esame e l'altra per registrare gli esami sostenuti. 
Le persone sono caratterizzate dai seguenti dati: codice fiscale, data di nascita (aaaa/mm/gg), tipo di patente da richiedere ( 0= A, 1=B, 2=C, 3=D, 4=F).  
Gli esami sono caratterizzati dai seguenti dati:  codice fiscale, data esame (aaaa/mm/gg), esito (0=non superato, 1=superato), tipo di patente.
Le persone sono inserite in un vettore di 5 liste, una per ogni tipo di patente. Le liste sono ordinate rispetto al codice fiscale.
Gli esami sono inseriti in una tabella di 5 righe, una per ogni tipo di patente.
Scrivere un programma C che codifichi  la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1)	Inserimento ordinato rispetto al codice fiscale di nuova persona 
2)	Visualizzazione del codice fiscale delle persone con data di nascita maggiore di un valore di soglia da richiedere tramite tastiera (chiedere anche il tipo di patente).
3)	Inserimento in tabella di un esame. 
4)	Ricerca di un esame ( chiedere il tipo di patente e  il codice fiscale)
5)	Salvataggio su file degli esami relativi a una certa data (chiedere tramite tastiera il nome del file e la data).
6)	Lettura da file e inserimento  in tabella degli esami

Liberare la memoria allocata dinamicamente al termine dell'esecuzione

Non usare variabili globali


*/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct persone {
       char codfisc[17],data_nasc[12];
       int tipo;
       };

struct atomo {
       struct persone dato;
       struct atomo *next;
       };

struct esami {
       char codfisc[17],data_es[12];
       int esito,tipo;
       };
       
void leggi_pe(struct persone *pe);
void ins_ord_pe (struct atomo *L[5],struct persone pe);
void vis_pe (struct atomo *L[5]);
void leggi_es (struct esami *es);
void ins_es (struct esami *T[5],int N[5],struct esami es);
void ricerca (struct esami *T[5],int N[5]);
void salva (struct esami *T[5],int N[5]);
void carica (struct esami *T[5],int N[5]);

main() {
       struct esami *T[5],es;
       int N[5],i,scelta;
       struct atomo *L[5],*a;
       struct persone pe;
       
       for(i=0;i<5;i++)
       {  T[i]=NULL;
          N[i]=0;
          L[i]=NULL;
       }
       
       do {
           printf("\n-------Menu'-------\n\n");
           printf("Scegli fra le seguenti opzioni:\n\n");
           printf("1.Inserimento persona\n2.Visualizzazione codice fiscale\n");
           printf("3.Inserimento esame\n4.Ricerca esame\n");
           printf("5.Salva\n6.Leggi da file\n0.Fine\n\n");
           scanf("%d",&scelta);
           switch(scelta) {
                          case 1: leggi_pe(&pe);
                                  ins_ord_pe(L,pe);
                                  break;
                          case 2: vis_pe(L);
                                  break;
                          case 3: leggi_es(&es);
                                  ins_es(T,N,es);
                                  break;
                          case 4: ricerca(T,N);
                                  break;
                          case 5: salva(T,N);
                                  break;
                          case 6: carica(T,N);
                                  break;
                          default:;
                          }
           }while(scelta!=0);
           
           for(i=0;i<5;i++)
           {  free(T[i]);
          
              while(L[i]!=NULL)
              {a=L[i];
               L[i]=a->next;
               free(a);
              }
          }
       }

void leggi_pe(struct persone *pe)
{
     printf("Codice fiscale: ");
     fflush(stdin);
     gets(pe->codfisc);
     printf("Data di nascita (aaaa/mm/gg): ");
     gets(pe->data_nasc);
     printf("Tipo patente (0=A, 1=B, 2=C, 3=D, 4=F): ");
     scanf("%d",&pe->tipo);
}


void ins_ord_pe (struct atomo *L[5],struct persone pe)
{
     struct atomo *aux, *l1,*l2;
     int i;
     
     
     
     aux=(struct atomo*)malloc(sizeof(struct atomo));
     if(aux==NULL)
       return;
     
     aux->dato=pe;
     i=pe.tipo;
     if(L[i]==NULL || strcmp(L[i]->dato.codfisc,pe.codfisc)<0)
       {
           aux->next=L[i];
           L[i]=aux;
           return;
       }
     
     l1=L[i];
     l2=l1->next;
     while(l2!=NULL)
     if(strcmp(l2->dato.codfisc,pe.codfisc)>0)
       break;
     
     else {l1=l2;
           l2=l2->next;
          }
     
     l1->next=aux;
     aux->next=l2;
}

     
void vis_pe (struct atomo *L[5])
{
     char data[12];
     int i;
     struct atomo *aux;
   
    
     printf("Tipo patente: ");
     scanf("%d",&i);
     printf("Data di nascita: ");
     scanf("%s",data);
     
     aux=L[i];
     while(aux!=NULL)
      { if(strcmp(aux->dato.data_nasc,data)>0)
             printf("Codice fiscale: %s\n",aux->dato.codfisc);
      
        aux=aux->next;
      }
        
     
}

     
void leggi_es (struct esami *es)
{
     printf("Codice fiscale: ");
     scanf("%s",es->codfisc);
     printf("Data esame (aaaa/mm/gg): ");
     scanf("%s",es->data_es);
     printf("Esito (0=non superato, 1=superato): ");
     scanf("%d",&es->esito);
     printf("Tipo di patente: ");
     scanf("%d",&es->tipo);
}
     

void ins_es (struct esami *T[5],int N[5],struct esami es)
{
     int i;
     struct esami *aux;
     
     i=es.tipo;
     aux=(struct esami*)realloc(T[i],(N[i]+1)*sizeof(struct esami));
     if(aux==NULL)
       return;
     
     T[i]=aux;
     aux[N[i]]=es;
     N[i]++;
}


void ricerca (struct esami *T[5],int N[5])
{
    char codfisc[20];
    int tipo,i;
     
     printf("tipo patente: ");
     scanf("%d",&tipo);
     printf("codice fiscale: ");
     scanf("%s",codfisc);
    
     for(i=0;i<N[tipo];i++)
      if(strcmp(codfisc,T[tipo][i].codfisc)==0)
         {
           printf("esame trovato\n");
           printf("Data esame : %s\n",T[tipo][i].data_es);
           if (T[tipo][i].esito == 1)
                printf("Esito esame:  superato");
           else printf("Esito esame:  non superato");
           return;
         }
                                                
     printf("non trovato");
}



void salva (struct esami *T[5],int N[5])
{
     FILE *pf;
     int i,j;
     char data[12];
     char nomefile[80];
      
     printf("Nome file: ");
     scanf("%s",nomefile);
     
     printf("Data esame: ");
     scanf("%s",data);
     
     pf=fopen(nomefile,"w");
     if(pf) { 
              for(i=0;i<5;i++)
                for(j=0;j<N[i];j++)
                  if(strcmp(data,T[i][j].data_es)==0)
                      fwrite(&T[i][j],sizeof(struct esami),1,pf);
              fclose(pf);
            }
}


void carica (struct esami *T[5],int N[5])
{
     FILE *pf;
     struct esami es;
     int i;
     char nomefile[80];
      
     printf("Nome file: ");
     scanf("%s",nomefile);
     
     pf=fopen(nomefile,"r");
     if(pf) {
              while(fread(&es,sizeof(struct esami),1,pf)!=0)
                { i=es.tipo;
                  ins_es(T,N,es);
                }
              fclose(pf);
              }
}
