/*
Scrivere un programma per la gestione di un centro servizi. 
Il programma deve prevedere due strutture dati. Una per le persone che devono richiedere un servizio e l'altra per registrare l'esecuzione del servizio. 
Per accedere ai servizi  necessario inserirsi in coda. Presso il centro servizi sono presenti 4 code, una per ogni tipo di servizio.  Al momento dell'inserimento di una persona in una delle 4 code sono richieste: codice fiscale, codice attivit,  tipo di servizio.
L'esecuzione di un servizio viene realizzata  eliminando il primo elemento da una delle code e inserendo il servizio effettuato in un vettore di 4 liste, una per ogni tipo di servizio.
L'inserimento del servizio effettuato richiede che vengano inseriti i seguenti dati:  codice fiscale, codice identificativo del servizio, data di esecuzione, tipo di servizio. 
Ogni lista  ordinata rispetto al codice fiscale. 

Scrivere un programma C che codifichi  la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1.	Inserimento in una delle code di una persona;
2.	Servizio di una delle code e inserimento ordinato nel vettore di liste di un servizio. Chiedere il tipo di servizio, il codice identificativo e la data
3.	Ricerca di un servizio effettuato (chiedere il tipo di servizio e il codice identificativo)
4.	Salvataggio su file degli elementi delle liste. 

All'avvio del programma i valori precedentemente salvati su file devono essere letti e copiati nel vettore di liste mediante una funzione di inizializzazione. 

Liberare la memoria allocata dinamicamente.

Non usare variabili globali
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
        char codfisc[20];
        int codatt, tipo;
        }persona;
        
struct atomocoda{
       persona dato;
       struct atomocoda *next;
         };
         
typedef struct{
        struct atomocoda *primo, *ultimo;
        }coda;
        
typedef struct{
        char codfisc[20], data[12];
        int codserv, tipo;
        }servizio;
        
struct lista{
       servizio dato;
       struct lista *next;
       };
       
void leggi_persona(persona *x);
void ins_coda(coda VQ[4], persona x);
void ricerca(struct lista *tl, int codserv);
void salva(struct lista *VL[4]);
void in_lista(struct lista **VL, servizio y);
void out_coda(coda *VQ);
void da_lista(struct lista **tl);
void leggi_servizio(servizio *y);
void inizializza_da_file( struct lista *VL[4]);

main(){
       int i, scelta, codserv;
       
       struct atomocoda *a;
       coda Q[4];
       struct lista *L[4];
       persona el;
       servizio se;
       
       
       for(i=0;i<4;i++)
          L[i]=NULL;
          
       for(i=0;i<4;i++){
          Q[i].primo=NULL;
          Q[i].ultimo=NULL;
          }
       
       inizializza_da_file(L);
       
       do{
          printf("\nScegli tra le seguenti opzioni:\n");
          printf("1)Inserimento in coda di una persona\n2)Servizio di una coda e inserimento ordinato in lista di un servizio\n");
          printf("3)Ricerca servizio effettuato\n4)Salva su file\n0)Fine\n  \n");
          scanf("%d", &scelta);
          switch(scelta){
                         case 1:
                              leggi_persona(&el);
                              i=el.tipo;
                              ins_coda(&Q[i], el);
                              break;
                         case 2:
                              printf("Tipo servizio: ");
                              scanf("%d", &i);
                              if(Q[i].primo!=NULL)
                                /* se la coda non e' vuota */
                                  {  /* prendiamo il primo elemento della coda  ed effettuamo l'out coda*/
                                     el=Q[i].primo->dato;
                                     out_coda(&Q[i]);
                                     
                                     /* copiamo il codice fiscale e il tipo in un servizio */
                                     se.tipo=el.tipo;
                                     strcpy(se.codfisc, el.codfisc);
                                     
                                     /* leggiamo da tastiera il codice e la data del servizio */ 
                                     printf("Codice identificativo servizio: ");
                                     scanf("%d", &se.codserv);
                                     printf("Data: ");
                                     scanf("%s", se.data);
                                     /* inseriamo in modo ordinato in lista */
                                     in_lista(&L[se.tipo], se);
                                  }
                                  else printf("Coda vuota!\n");
                              break;
                         case 3:
                              printf("Tipo servizio: "); 
                              scanf("%d", &i);
                              printf("Codice indentificativo : "); 
                              scanf("%d", &codserv);
                              ricerca(L[i], codserv);
                              break;
                         case 4:
                              salva(L);
                              break;  
                       default:;}
          }while(scelta!=0);
          
       for(i=0;i<4;i++)
          while(L[i]!=NULL)
            da_lista(&L[i]);
                        
       for(i=0;i<4;i++)
           while(Q[i].primo!=NULL)
           {
             a=Q[i].primo;
             Q[i].primo=a->next;
             free(a);
           }
          
}

void da_lista(struct lista **tl)
{
     struct lista *aux;
     
     aux=*tl;
     *tl=aux->next;
     free(aux);
}

void leggi_persona(persona *x){
     printf("Codice fiscale: \n"); 
     scanf("%s", x->codfisc);
     printf("Codice attivita': \n"); 
     scanf("%d", &x->codatt);
     printf("Tipo di servizio: \n"); 
     scanf("%d", &x->tipo);
}
     
void ins_coda(coda *Q, persona p){
     struct atomocoda *a;
     
     a=(struct atomocoda *)malloc(sizeof(struct atomocoda));
     if(a==NULL)
        return;
     a->dato=p;
     a->next=NULL;
     if(Q->primo==NULL){
        Q->primo=a;
        }else Q->ultimo->next=a;
     Q->ultimo=a;
}     
     
void out_coda(coda *Q)
{
     int i;
     struct atomocoda *l;
     
     l=Q->primo;
     Q->primo=l->next;
     free(l);
     
     if(Q->primo!=NULL)
        Q->ultimo=NULL;
} 

      
void in_lista(struct lista **L, servizio s)
{
     struct lista *a, *l1, *l2;
     
    
     a=(struct lista *) malloc(sizeof(struct lista));
     if(a==NULL)
        return;
     a->dato=s;
     
     if(*L==NULL || strcmp(s.codfisc, (*L)->dato.codfisc)<0)
        {
          a->next=*L;
          *L=a;
          return;
        }
        
     l2=*L;
     l1=l2->next;
     while(l1!=NULL)
       if(strcmp(s.codfisc, l1->dato.codfisc)<0)
          break;
       else {
              l2=l1;
              l1=l1->next;
            }
     a->next=l1;
     l2->next=a;
}
     
void ricerca(struct lista *tl, int codserv)
{
     while(tl!=NULL)
         if(tl->dato.codserv==codserv)
         {
           printf("Codice fiscale: %s\n", tl->dato.codfisc);
           return;
         }
         else tl=tl->next;
         
    /* si arriva in questo punto solo se non e' stato trovato*/    
    printf("Non trovato\n");  
            
}

     
void salva(struct lista *VL[4])
{
     FILE *pf;
     struct lista *a;
     servizio se;
     int i;
     
     
     pf=fopen("servizi.txt", "w");
     if(pf)
      {
       for(i=0;i<4;i++)
         {
           a=VL[i];
           while(a!=NULL)
           {
             se=a->dato;
             fwrite(&se, sizeof(servizio),1 ,pf);
             a=a->next;
           }  
         }
       fclose(pf);
     }
}      

void inizializza_da_file(struct lista *L[4])
{
    FILE *pf;
    servizio s;
    int i;
    
    pf=fopen("servizi.txt","r");
    if(pf){
        while(fread(&s,sizeof(servizio),1,pf)!=0)
        {
            i=s.tipo;
            in_lista(&L[i],s);
        }
        fclose(pf);
        }
}
